// Handle Loading of appMobi Library
document.addEventListener("appMobi.device.ready",InMobiPluginRegister,false);

function InMobiPluginRegister()
{
	if( AppMobi.device.platform == "Android" )
		AppMobi.device.registerLibrary("com.inmobi.inmobiplugin.InMobiPluginModule");
	if( AppMobi.device.platform == "iOS" )
		AppMobi.device.registerLibrary("InMobiPluginModule");
}

function InMobiPluginLoaded()
{	
	while (InMobiPlugin._constructors.length > 0) {
		var constructor = InMobiPlugin._constructors.shift();
		try {
			constructor();
		} catch(e) {
			alert("Failed to run constructor: " + e.message);
		}
	}
    
	// all constructors run, now fire the ready event
	InMobiPlugin.available = true;
	var e = document.createEvent('Events');
	e.initEvent('inmobiplugin.ready',true,true);
	document.dispatchEvent(e);
}

// Global name-prefixed object to store initialization info
if (typeof(InMobiPluginInfo) != 'object')
    InMobiPluginInfo = {};

/**
 * This provides a global namespace for accessing information
 */
InMobiPlugin = {
    queue: {
        ready: true,
        commands: [],
        timer: null
    },
    _constructors: []
};

/**
 * Add an initialization function to a queue that ensures our JavaScript 
 * object constructors will be run only once our module has been loaded
 */
InMobiPlugin.addConstructor = function(func) {
    var state = document.readyState;
    if ( ( state == 'loaded' || state == 'complete' ) && InMobiPluginInfo.ready != "undefined" )
	{
		func();
	}
    else
	{
        InMobiPlugin._constructors.push(func);
	}
};

//Begin Javascript definition of InMobiPlugin.Ads which bridges to InMobiAds
InMobiPlugin.Ads = function() 
{
}

//revised APIs

InMobiPlugin.Ads.prototype.initBannerAd = function(properties)
{
	if ( ( typeof properties.appId == "undefined" ) || ( typeof properties.appId != "string")) {
        properties.appId = null;
        
    }
    if ( ( typeof properties.adUnit == "undefined" ) || ( typeof properties.adUnit != "number") ) {
        properties.adUnit = -1;
        
    }
    if ( ( typeof properties.top == "undefined" ) || ( typeof properties.top != "number")) {
        properties.top = 0;
        
    }
    if ( ( typeof properties.left == "undefined" ) || ( typeof properties.left != "number")) {
        properties.left = 0;
        
    }
    if ( ( typeof properties.refreshInterval == "undefined" ) || ( typeof properties.refreshInterval != "number")) {
        properties.refreshInterval = 60;
        
    }
    if ( ( typeof properties.animationType == "undefined" ) || (properties.animationType == null) || (typeof properties.adUnit != "string")) {
    	properties.animationType = "Animation_CurlUp";
        
    }
    
    if( AppMobi.device.platform == "Android" )
    InMobiPluginAds.initBannerAd(properties.appId, properties.adUnit, properties.top, properties.left,  properties.refreshInterval, properties.animationType);
	if( AppMobi.device.platform == "iOS" )
    AppMobi.exec("InMobiAds.initBannerAd", properties.appId, properties.adUnit, properties.top, properties.left,  properties.refreshInterval, properties.animationType);
}

InMobiPlugin.Ads.prototype.setAdRequestProperties = function(properties)
{
    if(typeof properties == "undefined"){
    	return;
    }
    
	if ( ( typeof properties.postalCode == "undefined" ) || (properties.postalCode === "")|| (typeof properties.postalCode != "string")) {
        properties.postalCode = null;
        
    }
    if ( ( typeof properties.areaCode == "undefined" ) || (properties.areaCode === "")|| (typeof properties.areaCode != "string")) {
        properties.areaCode = null;
        
    }
    if ( ( typeof properties.dateOfBirth == "undefined" ) || (properties.dateOfBirth === "")|| (typeof properties.dateOfBirth != "string")) {
        properties.dateOfBirth = null;
        
    }
    if ( ( typeof properties.gender == "undefined" ) || (properties.gender === "")|| (typeof properties.gender != "string")) {
        properties.gender = null;
        
    }
    if ( ( typeof properties.keywords == "undefined" ) || (properties.keywords === "")|| (typeof properties.keywords != "string")) {
        properties.keywords = null;
        
    }
    if ( ( typeof properties.searchString == "undefined" ) || (properties.searchString === "")|| (typeof properties.searchString != "string")) {
        properties.searchString = null;
        
    }
    if ( ( typeof properties.income == "undefined" ) || (typeof properties.income != "number")) {
        properties.income = -1;
        
    }
    if ( ( typeof properties.education == "undefined" ) || (properties.education === "")|| (typeof properties.education != "string")) {
        properties.education = null;
       
    }
    if ( ( typeof properties.ethnicityType == "undefined" ) || (properties.ethnicityType === "")|| (typeof properties.ethnicityType != "string")) {
        properties.ethnicityType = null;
        
    }
    if ( ( typeof properties.age == "undefined" ) || (typeof properties.age != "number")) {
        properties.age = -1;
        
    }
    if ( ( typeof properties.interests == "undefined" ) || (properties.interests === "")|| (typeof properties.interests != "string")) {
        properties.interests = null;
        
    }
    if ( ( typeof properties.testMode == "undefined" ) || (typeof properties.testMode != "boolean") ) {
        properties.testMode = false;
        
    }
    if ( ( typeof properties.loginID == "undefined" ) || (properties.loginID === "")|| (typeof properties.loginID != "string")) {
        properties.loginID = null;
        
    }
    if ( ( typeof properties.sessionID == "undefined" ) || (properties.sessionID === "")|| (typeof properties.sessionID != "string")) {
        properties.sessionID = null;
        
    }
    if ( ( typeof properties.deviceIDMask == "undefined" ) || (typeof properties.deviceIDMask != "number") ) {
        properties.deviceIDMask = -1;
        
    }
    if ( ( typeof properties.cityLocation == "undefined" ) || (properties.cityLocation === "")|| (typeof properties.cityLocation != "string")) {
        properties.cityLocation = null;
        
    }
    if( AppMobi.device.platform == "Android" )
    InMobiPluginAds.setAdRequestProperties(properties.postalCode,properties.areaCode,properties.dateOfBirth,properties.gender,properties.keywords,properties.searchString,properties.income,properties.education,properties.ethnicityType,properties.age,properties.interests,properties.testMode,properties.loginID,properties.sessionID,properties.deviceIDMask,properties.cityLocation);
	if( AppMobi.device.platform == "iOS" )
    AppMobi.exec("InMobiAds.setAdRequestProperties",properties.postalCode,properties.areaCode,properties.dateOfBirth,properties.gender,properties.keywords,properties.searchString,properties.income,properties.education,properties.ethnicityType,properties.cityLocation,properties.interests,properties.testMode,properties.loginID,properties.sessionID,properties.deviceIDMask,properties.age);
}

InMobiPlugin.Ads.prototype.loadBannerAd = function()
{
    if( AppMobi.device.platform == "Android" )
    InMobiPluginAds.loadBannerAd();
	if( AppMobi.device.platform == "iOS" )
    AppMobi.exec("InMobiAds.loadBannerAd");
}

InMobiPlugin.Ads.prototype.setLogLevel = function(logLevel)
{
	if ( ( typeof logLevel == "undefined" ) || (typeof logLevel != "number") ) {
        logLevel = 0;
      
    }
    if( AppMobi.device.platform == "Android" )
    InMobiPluginAds.setLogLevel(logLevel);
	if( AppMobi.device.platform == "iOS" )
    AppMobi.exec("InMobiAds.setLogLevel",logLevel);
}


InMobiPlugin.Ads.prototype.initInterstitialAd = function(properties)
{
	if ( ( typeof properties.appId == "undefined" ) || (typeof properties.appId != "string")) {
        properties.appId = null;
        
    }
    if( AppMobi.device.platform == "Android" )
    InMobiPluginAds.initInterstitialAd(properties.appId);
	if( AppMobi.device.platform == "iOS" )
    AppMobi.exec("InMobiAds.initInterstitialAd",properties.appId);
}

InMobiPlugin.Ads.prototype.loadInterstitialAd = function()
{
    if( AppMobi.device.platform == "Android" )
    InMobiPluginAds.loadInterstitialAd();
	if( AppMobi.device.platform == "iOS" )
    AppMobi.exec("InMobiAds.loadInterstitialAd");
}

InMobiPlugin.Ads.prototype.showInterstitialAd = function()
{
    if( AppMobi.device.platform == "Android" )
    InMobiPluginAds.showInterstitialAd();
	if( AppMobi.device.platform == "iOS" )
    AppMobi.exec("InMobiAds.showInterstitialAd");
}

InMobiPlugin.Ads.prototype.removeBannerAd = function()
{
    if( AppMobi.device.platform == "Android" )
    InMobiPluginAds.removeBannerAd();
	if( AppMobi.device.platform == "iOS" )
    AppMobi.exec("InMobiAds.removeBannerAd");
}


//end of revised APIs
InMobiPlugin.addConstructor(function() {
    if (typeof InMobiPlugin.ads == "undefined") InMobiPlugin.ads = new InMobiPlugin.Ads();
});

// Begin Javascript definition of InMobiPlugin.Setup which bridges to InMobiPluginSetup
InMobiPlugin.Setup = function() 
{
    this.ready = null;
    try 
	{
		this.ready = InMobiPluginInfo.ready;
    } 
	catch(e) 
	{
    }
}

InMobiPlugin.addConstructor(function() {
    if (typeof InMobiPlugin.setup == "undefined") InMobiPlugin.setup = new InMobiPlugin.Setup();
});
