// Handle Loading of appMobi Library
document.addEventListener("appMobi.device.ready",MyPluginRegister,false);

function MyPluginRegister()
{
	if( AppMobi.device.platform == "Android" )
		AppMobi.device.registerLibrary("com.mycompany.myplugin.MyPluginModule");
	if( AppMobi.device.platform == "iOS" )
		AppMobi.device.registerLibrary("MyPluginModule");
}

function MyPluginLoaded()
{	
	while (MyPlugin._constructors.length > 0) {
		var constructor = MyPlugin._constructors.shift();
		try {
			constructor();
		} catch(e) {
			alert("Failed to run constructor: " + e.message);
		}
	}
    
	// all constructors run, now fire the ready event
	MyPlugin.available = true;
	var e = document.createEvent('Events');
	e.initEvent('myplugin.ready',true,true);
	document.dispatchEvent(e);
}

// Global name-prefixed object to store initialization info
if (typeof(MyPluginInfo) != 'object')
    MyPluginInfo = {};

/**
 * This provides a global namespace for accessing information
 */
MyPlugin = {
    queue: {
        ready: true,
        commands: [],
        timer: null
    },
    _constructors: []
};

/**
 * Add an initialization function to a queue that ensures our JavaScript 
 * object constructors will be run only once our module has been loaded
 */
MyPlugin.addConstructor = function(func) {
    var state = document.readyState;
    if ( ( state == 'loaded' || state == 'complete' ) && MyPluginInfo.ready != "undefined" )
	{
		func();
	}
    else
	{
        MyPlugin._constructors.push(func);
	}
};

// Begin Javascript definition of MyPlugin.Worker which bridges to MyPluginWorker
MyPlugin.Worker = function() 
{
}

MyPlugin.Worker.prototype.startWork = function(message, interval)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.startWork(message, interval);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.startWork", message, interval);
}

MyPlugin.Worker.prototype.stopWork = function()
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.stopWork();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.stopWork");
}

//init
MyPlugin.Worker.prototype.init = function()
{
	if( AppMobi.device.platform == "Android" )
        MyPluginWorker.init();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.init");
}
/* NON JSON
//Share Article Function
MyPlugin.Worker.prototype.share = function(title, url)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.share(title, url);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.share", title, url);
}
*/

//Share Article Function
MyPlugin.Worker.prototype.share = function(json)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.share(json);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.share", json);
}



//Google Analytics
MyPlugin.Worker.prototype.setTrackerID = function(trackerID)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.setTrackerID(trackerID);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.setTrackerID", trackerID);
}

MyPlugin.Worker.prototype.mPlusAnalytics = function(view)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.sendView(view);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.mPlusAnalytics", view);
}

MyPlugin.Worker.prototype.sendView = function(view)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.sendView(view);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.sendView", view);
}
MyPlugin.Worker.prototype.sendEvent = function(category, action, label, value)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.sendEvent(category, action, label, value);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.sendEvent", category, action, label, value);
}

//Setup Ads
MyPlugin.Worker.prototype.setupAd = function(uid, partners, posX, posY)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.setupAd(uid, partners, posX, posY);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.setupAd",uid, partners, posX, posY );
}

//Show Ad
MyPlugin.Worker.prototype.showAd = function()
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.showAd();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.showAd" );
}

//Hide Ad
MyPlugin.Worker.prototype.hideAd = function()
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.hideAd();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.hideAd" );
}

//Refresh Ad
MyPlugin.Worker.prototype.refreshAd = function()
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.refreshAd();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.refreshAd" );
}

//Remove Ad
MyPlugin.Worker.prototype.removeAd = function()
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.removeAd();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.removeAd" );
}

//showInAppWebView
MyPlugin.Worker.prototype.showInAppWebView = function(title, url, posX, posY, width, height)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.showInAppWebView(title, url, posX, posY, width, height);
	if( AppMobi.device.platform == "iOS" ){
		AppMobi.exec("MyPluginWorker.showInAppWebView", title, url, posX, posY, width, height);
    }
}

MyPlugin.Worker.prototype.getCurrentLoc = function()
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.getCurrentLoc();
	if( AppMobi.device.platform == "iOS" ){
		console.log("Not needed for iOS");
    }
}

/////////////////////////////////////
//Content webview stuff
MyPlugin.Worker.prototype.loadPage = function(js)
{
	if( AppMobi.device.platform == "Android" )
        MyPluginWorker.loadPage(js);
	if( AppMobi.device.platform == "iOS" ){
        AppMobi.exec("MyPluginWorker.loadPage", js);
    }
}

MyPlugin.Worker.prototype.backWebview = function(num)
{
	if( AppMobi.device.platform == "Android" )
        MyPluginWorker.backWebview(0-num);
	if( AppMobi.device.platform == "iOS" ){
        AppMobi.exec("MyPluginWorker.backWebview", num);
    }
}

MyPlugin.Worker.prototype.runJS = function(js)
{
	if( AppMobi.device.platform == "Android" )
        MyPluginWorker.runJS(js);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.runJS", js);
}

MyPlugin.Worker.prototype.loadWebViewUrl = function(js)
{
	if( AppMobi.device.platform == "Android" )
        MyPluginWorker.loadWebViewUrl(js);
	if( AppMobi.device.platform == "iOS" ){
        AppMobi.exec("MyPluginWorker.loadWebViewUrl", js);
    }
}


MyPlugin.Worker.prototype.closeWebview = function(js)
{
	if( AppMobi.device.platform == "Android" )
        MyPluginWorker.closeWebview();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.closeWebview", js);
}

MyPlugin.Worker.prototype.menuWebview = function(){
    if( AppMobi.device.platform == "Android" )
        MyPluginWorker.menuWebview();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.menuWebview");
}



//hideInAppWebView
MyPlugin.Worker.prototype.hideInAppWebView = function()
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.hideInAppWebView();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.hideInAppWebView" );
}

//refillWal
MyPlugin.Worker.prototype.refill = function(json)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.refill(json);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.refill", json);
}

//hasCamera
MyPlugin.Worker.prototype.hasCamera = function()
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.hasCamera();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.hasCamera");
}

//Cloud sharing
MyPlugin.Worker.prototype.saveToCloud = function(json)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.saveToCloud(json);
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.saveToCloud", json);
}

//http Request
MyPlugin.Worker.prototype.doHttpRequest = function(json)
{
	if( AppMobi.device.platform == "Android" )
        {/*This function is temporarily only available on iOS
          MyPluginWorker.doHttpRequest(json);
        */}
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.doHttpRequest", json);
}

//Cloud sharing
MyPlugin.Worker.prototype.fileClear = function()
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.fileClear();
	if( AppMobi.device.platform == "iOS" )
		console.log("No iOS version of this function");
}

//Cloud sharing
MyPlugin.Worker.prototype.quitApp = function()
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.quitApp();
	if( AppMobi.device.platform == "iOS" )
		console.log("No iOS version of this function");
}



MyPlugin.addConstructor(function() {
    if (typeof MyPlugin.worker == "undefined") MyPlugin.worker = new MyPlugin.Worker();
});


// Begin Javascript definition of MyPlugin.Setup which bridges to MyPluginSetup
MyPlugin.Setup = function() 
{
    this.ready = null;
    try 
	{
		this.ready = MyPluginInfo.ready;
    } 
	catch(e) 
	{
    }
}

MyPlugin.addConstructor(function() {
    if (typeof MyPlugin.setup == "undefined") MyPlugin.setup = new MyPlugin.Setup();
});




/*
//Cloud sharing
MyPlugin.Worker.prototype.appShareList = function(json)
{
	if( AppMobi.device.platform == "Android" )
		MyPluginWorker.appShareList();
	if( AppMobi.device.platform == "iOS" )
		AppMobi.exec("MyPluginWorker.appShareList");
}
*/


